onerror {resume}
quietly WaveActivateNextPane {} 0
add wave -noupdate -format Logic /user_app_tb_vhd/reset_n
add wave -noupdate -format Logic /user_app_tb_vhd/user_clk
add wave -noupdate -format Logic /user_app_tb_vhd/user_enable
add wave -noupdate -format Logic /user_app_tb_vhd/fresp_valid
add wave -noupdate -format Logic /user_app_tb_vhd/fresp_ts
add wave -noupdate -format Logic /user_app_tb_vhd/freq_rw_n
add wave -noupdate -format Logic /user_app_tb_vhd/freq_ts
add wave -noupdate -format Logic /user_app_tb_vhd/freq_valid
add wave -noupdate -format Logic /user_app_tb_vhd/uresp_full
add wave -noupdate -format Literal /user_app_tb_vhd/fresp_data
add wave -noupdate -format Literal /user_app_tb_vhd/freq_addr
add wave -noupdate -format Literal /user_app_tb_vhd/freq_size
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/freq_data
add wave -noupdate -format Literal /user_app_tb_vhd/ureq_addr
add wave -noupdate -format Literal /user_app_tb_vhd/ureq_size
add wave -noupdate -format Literal /user_app_tb_vhd/ureq_mask
add wave -noupdate -format Logic /user_app_tb_vhd/ureq_rw_n
add wave -noupdate -format Literal /user_app_tb_vhd/ureq_data
add wave -noupdate -format Logic /user_app_tb_vhd/ureq_ts
add wave -noupdate -format Logic /user_app_tb_vhd/fresp_enable
add wave -noupdate -format Logic /user_app_tb_vhd/freq_enable
add wave -noupdate -format Logic /user_app_tb_vhd/uresp_ts
add wave -noupdate -format Literal /user_app_tb_vhd/uresp_size
add wave -noupdate -format Literal /user_app_tb_vhd/uresp_srctag
add wave -noupdate -format Literal /user_app_tb_vhd/uresp_data
add wave -noupdate -divider user_app
add wave -noupdate -format Literal /user_app_tb_vhd/uut/pwm_write_data
add wave -noupdate -format Literal /user_app_tb_vhd/uut/pwm_write_row
add wave -noupdate -format Literal /user_app_tb_vhd/uut/pwm_write_col
add wave -noupdate -format Literal /user_app_tb_vhd/uut/ftr_pointer
add wave -noupdate -format Literal /user_app_tb_vhd/uut/start_count
add wave -noupdate -format Literal /user_app_tb_vhd/uut/pwm_table
add wave -noupdate -format Literal /user_app_tb_vhd/uut/index_counter
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/count_gen
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/count_cooldown
add wave -noupdate -format Logic /user_app_tb_vhd/uut/filter_comp_finished
add wave -noupdate -divider pwm
add wave -noupdate -format Logic /user_app_tb_vhd/uut/pwm_inst/valid
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/pwm_inst/elem_in
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/pwm_inst/index_in
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/pwm_inst/data_out
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/pwm_inst/index_out
add wave -noupdate -format Logic /user_app_tb_vhd/uut/pwm_inst/data_out_valid
add wave -noupdate -divider filter
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/filter_inst/data_in
add wave -noupdate -format Logic /user_app_tb_vhd/uut/filter_inst/filter_comp_finished
add wave -noupdate -format Logic /user_app_tb_vhd/uut/filter_inst/data_valid
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/filter_inst/sum
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/filter_inst/data_out
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/filter_inst/counter
add wave -noupdate -divider writer
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/data_in
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/valid
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/ureq_addr
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/ureq_data
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/ureq_size
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/ureq_ts
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/flush
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/read_enable
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/stall
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/empty
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/overflow
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/temp_counter
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/counter
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/read_address
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/write_address
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/addr_ptr
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/enable_brams_a
add wave -noupdate -format Logic /user_app_tb_vhd/uut/write_inst/enable_brams_b
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/do7
add wave -noupdate -format Literal -radix unsigned /user_app_tb_vhd/uut/write_inst/do8
TreeUpdate [SetDefaultTree]
WaveRestoreCursors {{Cursor 1} {4325610 ns} 0}
configure wave -namecolwidth 413
configure wave -valuecolwidth 100
configure wave -justifyvalue left
configure wave -signalnamewidth 0
configure wave -snapdistance 10
configure wave -datasetprefix 0
configure wave -rowmargin 4
configure wave -childrowmargin 2
configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40
configure wave -timeline 0
update
WaveRestoreZoom {4325606 ns} {4325638 ns}
