--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 8.2i
--  \   \         Application : ISE
--  /   /         Filename : user_app_tbw.vhw
-- /___/   /\     Timestamp : Fri Apr  6 20:47:53 2007
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: user_app_tbw
--Device: Xilinx
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;
use ieee.numeric_std.ALL;
library work;
use work.user_pkg.all;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE STD.TEXTIO.ALL;

ENTITY user_app_tbw IS
END user_app_tbw;

ARCHITECTURE testbench_arch OF user_app_tbw IS
    COMPONENT user_app
        PORT (
            debug : Out std_logic_vector (25 DownTo 0);
            reset_n : In std_logic;
            user_clk : In std_logic;
            user_enable : In std_logic;
            rt_ready : In std_logic;
            qdr_ready : In std_logic;
            dr_1 : In std_logic_vector (71 DownTo 0);
            ar_1 : Out std_logic_vector (19 DownTo 0);
            aw_1 : Out std_logic_vector (19 DownTo 0);
            r_n_1 : Out std_logic;
            w_n_1 : Out std_logic;
            bw_n_1 : Out std_logic_vector (7 DownTo 0);
            dw_1 : Out std_logic_vector (71 DownTo 0);
            dr_2 : In std_logic_vector (71 DownTo 0);
            ar_2 : Out std_logic_vector (19 DownTo 0);
            aw_2 : Out std_logic_vector (19 DownTo 0);
            r_n_2 : Out std_logic;
            w_n_2 : Out std_logic;
            bw_n_2 : Out std_logic_vector (7 DownTo 0);
            dw_2 : Out std_logic_vector (71 DownTo 0);
            dr_3 : In std_logic_vector (71 DownTo 0);
            ar_3 : Out std_logic_vector (19 DownTo 0);
            aw_3 : Out std_logic_vector (19 DownTo 0);
            r_n_3 : Out std_logic;
            w_n_3 : Out std_logic;
            bw_n_3 : Out std_logic_vector (7 DownTo 0);
            dw_3 : Out std_logic_vector (71 DownTo 0);
            dr_4 : In std_logic_vector (71 DownTo 0);
            ar_4 : Out std_logic_vector (19 DownTo 0);
            aw_4 : Out std_logic_vector (19 DownTo 0);
            r_n_4 : Out std_logic;
            w_n_4 : Out std_logic;
            bw_n_4 : Out std_logic_vector (7 DownTo 0);
            dw_4 : Out std_logic_vector (71 DownTo 0);
            ureq_srctag : In std_logic_vector (4 DownTo 0);
            ureq_full : In std_logic;
            ureq_notag : In std_logic;
            ureq_addr : Out std_logic_vector (39 DownTo 3);
            ureq_size : Out std_logic_vector (2 DownTo 0);
            ureq_mask : Out std_logic_vector (7 DownTo 0);
            ureq_rw_n : Out std_logic;
            ureq_data : Out std_logic_vector (63 DownTo 0);
            ureq_ts : Out std_logic;
            ureq_byte_req : Out std_logic;
            fresp_valid : In std_logic;
            fresp_ts : In std_logic;
            fresp_size : In std_logic_vector (2 DownTo 0);
            fresp_srctag : In std_logic_vector (4 DownTo 0);
            fresp_data : In std_logic_vector (63 DownTo 0);
            fresp_enable : Out std_logic;
            freq_addr : In std_logic_vector (39 DownTo 3);
            freq_size : In std_logic_vector (3 DownTo 0);
            freq_srctag : In std_logic_vector (4 DownTo 0);
            freq_mask : In std_logic_vector (7 DownTo 0);
            freq_rw_n : In std_logic;
            freq_ts : In std_logic;
            freq_valid : In std_logic;
            freq_data : In std_logic_vector (63 DownTo 0);
            freq_enable : Out std_logic;
            uresp_full : In std_logic;
            uresp_ts : Out std_logic;
            uresp_size : Out std_logic_vector (3 DownTo 0);
            uresp_srctag : Out std_logic_vector (4 DownTo 0);
            uresp_data : Out std_logic_vector (63 DownTo 0)
        );
    END COMPONENT;

    SIGNAL debug : std_logic_vector (25 DownTo 0) := "00000000000000000000000000";
    SIGNAL reset_n : std_logic := '0';
    SIGNAL user_clk : std_logic := '0';
    SIGNAL user_enable : std_logic := '0';
    SIGNAL rt_ready : std_logic := '0';
    SIGNAL qdr_ready : std_logic := '0';
    SIGNAL dr_1 : std_logic_vector (71 DownTo 0) := "000000000000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL ar_1 : std_logic_vector (19 DownTo 0) := "00000000000000000000";
    SIGNAL aw_1 : std_logic_vector (19 DownTo 0) := "00000000000000000000";
    SIGNAL r_n_1 : std_logic := '1';
    SIGNAL w_n_1 : std_logic := '1';
    SIGNAL bw_n_1 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL dw_1 : std_logic_vector (71 DownTo 0) := "000000000000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL dr_2 : std_logic_vector (71 DownTo 0) := "000000000000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL ar_2 : std_logic_vector (19 DownTo 0) := "00000000000000000000";
    SIGNAL aw_2 : std_logic_vector (19 DownTo 0) := "00000000000000000000";
    SIGNAL r_n_2 : std_logic := '1';
    SIGNAL w_n_2 : std_logic := '1';
    SIGNAL bw_n_2 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL dw_2 : std_logic_vector (71 DownTo 0) := "000000000000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL dr_3 : std_logic_vector (71 DownTo 0) := "000000000000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL ar_3 : std_logic_vector (19 DownTo 0) := "00000000000000000000";
    SIGNAL aw_3 : std_logic_vector (19 DownTo 0) := "00000000000000000000";
    SIGNAL r_n_3 : std_logic := '1';
    SIGNAL w_n_3 : std_logic := '1';
    SIGNAL bw_n_3 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL dw_3 : std_logic_vector (71 DownTo 0) := "000000000000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL dr_4 : std_logic_vector (71 DownTo 0) := "000000000000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL ar_4 : std_logic_vector (19 DownTo 0) := "00000000000000000000";
    SIGNAL aw_4 : std_logic_vector (19 DownTo 0) := "00000000000000000000";
    SIGNAL r_n_4 : std_logic := '1';
    SIGNAL w_n_4 : std_logic := '1';
    SIGNAL bw_n_4 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL dw_4 : std_logic_vector (71 DownTo 0) := "000000000000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL ureq_srctag : std_logic_vector (4 DownTo 0) := "00000";
    SIGNAL ureq_full : std_logic := '0';
    SIGNAL ureq_notag : std_logic := '0';
    SIGNAL ureq_addr : std_logic_vector (39 DownTo 3) := "0000000000000000000000000000000000000";
    SIGNAL ureq_size : std_logic_vector (2 DownTo 0) := "000";
    SIGNAL ureq_mask : std_logic_vector (7 DownTo 0) := "11111111";
    SIGNAL ureq_rw_n : std_logic := '0';
    SIGNAL ureq_data : std_logic_vector (63 DownTo 0) := "0000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL ureq_ts : std_logic := '0';
    SIGNAL ureq_byte_req : std_logic := '0';
    SIGNAL fresp_valid : std_logic := '0';
    SIGNAL fresp_ts : std_logic := '0';
    SIGNAL fresp_size : std_logic_vector (2 DownTo 0) := "000";
    SIGNAL fresp_srctag : std_logic_vector (4 DownTo 0) := "00000";
    SIGNAL fresp_data : std_logic_vector (63 DownTo 0) := "0000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL fresp_enable : std_logic := '0';
    SIGNAL freq_addr : std_logic_vector (39 DownTo 3) := "0000000000000000000000000000000000000";
    SIGNAL freq_size : std_logic_vector (3 DownTo 0) := "0000";
    SIGNAL freq_srctag : std_logic_vector (4 DownTo 0) := "00000";
    SIGNAL freq_mask : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL freq_rw_n : std_logic := '0';
    SIGNAL freq_ts : std_logic := '0';
    SIGNAL freq_valid : std_logic := '0';
    SIGNAL freq_data : std_logic_vector (63 DownTo 0) := "0000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL freq_enable : std_logic := '0';
    SIGNAL uresp_full : std_logic := '0';
    SIGNAL uresp_ts : std_logic := '0';
    SIGNAL uresp_size : std_logic_vector (3 DownTo 0) := "0000";
    SIGNAL uresp_srctag : std_logic_vector (4 DownTo 0) := "00000";
    SIGNAL uresp_data : std_logic_vector (63 DownTo 0) := "0000000000000000000000000000000000000000000000000000000000000000";

    SHARED VARIABLE TX_ERROR : INTEGER := 0;
    SHARED VARIABLE TX_OUT : LINE;

    constant PERIOD : time := 200 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 0 ns;

    BEGIN
        UUT : user_app
        PORT MAP (
            debug => debug,
            reset_n => reset_n,
            user_clk => user_clk,
            user_enable => user_enable,
            rt_ready => rt_ready,
            qdr_ready => qdr_ready,
            dr_1 => dr_1,
            ar_1 => ar_1,
            aw_1 => aw_1,
            r_n_1 => r_n_1,
            w_n_1 => w_n_1,
            bw_n_1 => bw_n_1,
            dw_1 => dw_1,
            dr_2 => dr_2,
            ar_2 => ar_2,
            aw_2 => aw_2,
            r_n_2 => r_n_2,
            w_n_2 => w_n_2,
            bw_n_2 => bw_n_2,
            dw_2 => dw_2,
            dr_3 => dr_3,
            ar_3 => ar_3,
            aw_3 => aw_3,
            r_n_3 => r_n_3,
            w_n_3 => w_n_3,
            bw_n_3 => bw_n_3,
            dw_3 => dw_3,
            dr_4 => dr_4,
            ar_4 => ar_4,
            aw_4 => aw_4,
            r_n_4 => r_n_4,
            w_n_4 => w_n_4,
            bw_n_4 => bw_n_4,
            dw_4 => dw_4,
            ureq_srctag => ureq_srctag,
            ureq_full => ureq_full,
            ureq_notag => ureq_notag,
            ureq_addr => ureq_addr,
            ureq_size => ureq_size,
            ureq_mask => ureq_mask,
            ureq_rw_n => ureq_rw_n,
            ureq_data => ureq_data,
            ureq_ts => ureq_ts,
            ureq_byte_req => ureq_byte_req,
            fresp_valid => fresp_valid,
            fresp_ts => fresp_ts,
            fresp_size => fresp_size,
            fresp_srctag => fresp_srctag,
            fresp_data => fresp_data,
            fresp_enable => fresp_enable,
            freq_addr => freq_addr,
            freq_size => freq_size,
            freq_srctag => freq_srctag,
            freq_mask => freq_mask,
            freq_rw_n => freq_rw_n,
            freq_ts => freq_ts,
            freq_valid => freq_valid,
            freq_data => freq_data,
            freq_enable => freq_enable,
            uresp_full => uresp_full,
            uresp_ts => uresp_ts,
            uresp_size => uresp_size,
            uresp_srctag => uresp_srctag,
            uresp_data => uresp_data
        );

        PROCESS    -- clock process for user_clk
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                user_clk <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                user_clk <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            PROCEDURE CHECK_ar_1(
                next_ar_1 : std_logic_vector (19 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ar_1 /= next_ar_1) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ar_1="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ar_1);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ar_1);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ar_2(
                next_ar_2 : std_logic_vector (19 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ar_2 /= next_ar_2) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ar_2="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ar_2);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ar_2);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ar_3(
                next_ar_3 : std_logic_vector (19 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ar_3 /= next_ar_3) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ar_3="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ar_3);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ar_3);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ar_4(
                next_ar_4 : std_logic_vector (19 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ar_4 /= next_ar_4) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ar_4="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ar_4);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ar_4);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_aw_1(
                next_aw_1 : std_logic_vector (19 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (aw_1 /= next_aw_1) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns aw_1="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, aw_1);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_aw_1);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_aw_2(
                next_aw_2 : std_logic_vector (19 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (aw_2 /= next_aw_2) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns aw_2="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, aw_2);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_aw_2);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_aw_3(
                next_aw_3 : std_logic_vector (19 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (aw_3 /= next_aw_3) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns aw_3="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, aw_3);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_aw_3);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_aw_4(
                next_aw_4 : std_logic_vector (19 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (aw_4 /= next_aw_4) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns aw_4="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, aw_4);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_aw_4);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_bw_n_1(
                next_bw_n_1 : std_logic_vector (7 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (bw_n_1 /= next_bw_n_1) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns bw_n_1="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, bw_n_1);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_bw_n_1);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_bw_n_2(
                next_bw_n_2 : std_logic_vector (7 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (bw_n_2 /= next_bw_n_2) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns bw_n_2="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, bw_n_2);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_bw_n_2);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_bw_n_3(
                next_bw_n_3 : std_logic_vector (7 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (bw_n_3 /= next_bw_n_3) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns bw_n_3="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, bw_n_3);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_bw_n_3);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_bw_n_4(
                next_bw_n_4 : std_logic_vector (7 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (bw_n_4 /= next_bw_n_4) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns bw_n_4="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, bw_n_4);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_bw_n_4);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_debug(
                next_debug : std_logic_vector (25 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (debug /= next_debug) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns debug="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, debug);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_debug);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_dw_1(
                next_dw_1 : std_logic_vector (71 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (dw_1 /= next_dw_1) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns dw_1="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, dw_1);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_dw_1);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_dw_2(
                next_dw_2 : std_logic_vector (71 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (dw_2 /= next_dw_2) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns dw_2="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, dw_2);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_dw_2);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_dw_3(
                next_dw_3 : std_logic_vector (71 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (dw_3 /= next_dw_3) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns dw_3="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, dw_3);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_dw_3);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_dw_4(
                next_dw_4 : std_logic_vector (71 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (dw_4 /= next_dw_4) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns dw_4="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, dw_4);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_dw_4);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_freq_enable(
                next_freq_enable : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (freq_enable /= next_freq_enable) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns freq_enable="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, freq_enable);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_freq_enable);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_fresp_enable(
                next_fresp_enable : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (fresp_enable /= next_fresp_enable) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns fresp_enable="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, fresp_enable);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_fresp_enable);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_r_n_1(
                next_r_n_1 : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (r_n_1 /= next_r_n_1) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns r_n_1="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, r_n_1);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_r_n_1);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_r_n_2(
                next_r_n_2 : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (r_n_2 /= next_r_n_2) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns r_n_2="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, r_n_2);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_r_n_2);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_r_n_3(
                next_r_n_3 : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (r_n_3 /= next_r_n_3) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns r_n_3="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, r_n_3);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_r_n_3);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_r_n_4(
                next_r_n_4 : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (r_n_4 /= next_r_n_4) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns r_n_4="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, r_n_4);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_r_n_4);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ureq_addr(
                next_ureq_addr : std_logic_vector (39 DownTo 3);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ureq_addr /= next_ureq_addr) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ureq_addr="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ureq_addr);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ureq_addr);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ureq_byte_req(
                next_ureq_byte_req : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ureq_byte_req /= next_ureq_byte_req) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ureq_byte_req="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ureq_byte_req);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ureq_byte_req);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ureq_data(
                next_ureq_data : std_logic_vector (63 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ureq_data /= next_ureq_data) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ureq_data="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ureq_data);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ureq_data);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ureq_mask(
                next_ureq_mask : std_logic_vector (7 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ureq_mask /= next_ureq_mask) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ureq_mask="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ureq_mask);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ureq_mask);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ureq_rw_n(
                next_ureq_rw_n : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ureq_rw_n /= next_ureq_rw_n) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ureq_rw_n="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ureq_rw_n);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ureq_rw_n);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ureq_size(
                next_ureq_size : std_logic_vector (2 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ureq_size /= next_ureq_size) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ureq_size="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ureq_size);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ureq_size);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_ureq_ts(
                next_ureq_ts : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (ureq_ts /= next_ureq_ts) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns ureq_ts="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, ureq_ts);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_ureq_ts);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_uresp_data(
                next_uresp_data : std_logic_vector (63 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (uresp_data /= next_uresp_data) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns uresp_data="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, uresp_data);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_uresp_data);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_uresp_size(
                next_uresp_size : std_logic_vector (3 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (uresp_size /= next_uresp_size) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns uresp_size="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, uresp_size);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_uresp_size);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_uresp_srctag(
                next_uresp_srctag : std_logic_vector (4 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (uresp_srctag /= next_uresp_srctag) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns uresp_srctag="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, uresp_srctag);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_uresp_srctag);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_uresp_ts(
                next_uresp_ts : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (uresp_ts /= next_uresp_ts) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns uresp_ts="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, uresp_ts);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_uresp_ts);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_w_n_1(
                next_w_n_1 : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (w_n_1 /= next_w_n_1) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns w_n_1="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, w_n_1);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_w_n_1);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_w_n_2(
                next_w_n_2 : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (w_n_2 /= next_w_n_2) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns w_n_2="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, w_n_2);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_w_n_2);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_w_n_3(
                next_w_n_3 : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (w_n_3 /= next_w_n_3) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns w_n_3="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, w_n_3);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_w_n_3);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_w_n_4(
                next_w_n_4 : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (w_n_4 /= next_w_n_4) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns w_n_4="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, w_n_4);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_w_n_4);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            BEGIN
                -- -------------  Current Time:  85ns
                WAIT FOR 85 ns;
                reset_n <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  285ns
                WAIT FOR 200 ns;
                user_enable <= '1';
                rt_ready <= '1';
                qdr_ready <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  315ns
                WAIT FOR 30 ns;
                CHECK_freq_enable('1', 315);
                CHECK_ureq_addr("1111111111111111111111111111111111111", 315);
                CHECK_ureq_data("1111111111111111111111111111111111111111111111111111111111111111", 315);
                -- -------------------------------------
                -- -------------  Current Time:  685ns
                WAIT FOR 370 ns;
                freq_ts <= '1';
                freq_valid <= '1';
                freq_addr <= "0000000000000000000000000000000001010";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000011000";
                -- -------------------------------------
                -- -------------  Current Time:  715ns
                WAIT FOR 30 ns;
                CHECK_uresp_data("0000000000000000000000000000000000000000000000000000000000011000", 715);
                -- -------------------------------------
                -- -------------  Current Time:  885ns
                WAIT FOR 170 ns;
                fresp_valid <= '0';
                fresp_ts <= '0';
                freq_ts <= '0';
                freq_valid <= '0';
                freq_addr <= "0000000000000000000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  1085ns
                WAIT FOR 200 ns;
                freq_ts <= '1';
                freq_valid <= '1';
                freq_addr <= "0000000000000000000000000000000001011";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000011";
                -- -------------------------------------
                -- -------------  Current Time:  1115ns
                WAIT FOR 30 ns;
                CHECK_uresp_data("0000000000000000000000000000000000000000000000000000000000000011", 1115);
                -- -------------------------------------
                -- -------------  Current Time:  1285ns
                WAIT FOR 170 ns;
                freq_ts <= '0';
                freq_valid <= '0';
                freq_addr <= "0000000000000000000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  1515ns
                WAIT FOR 230 ns;
                CHECK_r_n_1('0', 1515);
                CHECK_r_n_2('0', 1515);
                CHECK_r_n_3('0', 1515);
                CHECK_r_n_4('0', 1515);
                -- -------------------------------------
                -- -------------  Current Time:  3285ns
                WAIT FOR 1770 ns;
                dr_1 <= "000000000000000000000000000000000000000000000000000000000000000000000001";
                -- -------------------------------------
                -- -------------  Current Time:  3315ns
                WAIT FOR 30 ns;
                CHECK_ar_1("00000000000000000001", 3315);
                CHECK_ar_2("00000000000000000001", 3315);
                CHECK_ar_3("00000000000000000001", 3315);
                CHECK_ar_4("00000000000000000001", 3315);
                -- -------------------------------------
                -- -------------  Current Time:  3685ns
                WAIT FOR 370 ns;
                dr_1 <= "000000000000000000000000000000000000000000000000000000000000000000000001";
                -- -------------------------------------
                -- -------------  Current Time:  4085ns
                WAIT FOR 400 ns;
                dr_1 <= "000000000000000000000000000000000000000000000000000000000000000000000001";
                -- -------------------------------------
                -- -------------  Current Time:  4485ns
                WAIT FOR 400 ns;
                dr_1 <= "000000000000000000000000000000000000000000000000000000000000000000000001";
                -- -------------------------------------
                -- -------------  Current Time:  4685ns
                WAIT FOR 200 ns;
                dr_1 <= "000000000000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  4885ns
                WAIT FOR 200 ns;
                dr_1 <= "000000000000000000000000000000000000000000000000000000000000000000000010";
                -- -------------------------------------
                -- -------------  Current Time:  5115ns
                WAIT FOR 230 ns;
                CHECK_ar_1("00000000000000000010", 5115);
                CHECK_ar_2("00000000000000000010", 5115);
                CHECK_ar_3("00000000000000000010", 5115);
                CHECK_ar_4("00000000000000000010", 5115);
                -- -------------------------------------
                -- -------------  Current Time:  6485ns
                WAIT FOR 1370 ns;
                dr_1 <= "000000000000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  6915ns
                WAIT FOR 430 ns;
                CHECK_ar_1("00000000000000000011", 6915);
                CHECK_ar_2("00000000000000000011", 6915);
                CHECK_ar_3("00000000000000000011", 6915);
                CHECK_ar_4("00000000000000000011", 6915);
                -- -------------------------------------
                -- -------------  Current Time:  7115ns
                WAIT FOR 200 ns;
                CHECK_r_n_1('1', 7115);
                CHECK_r_n_2('1', 7115);
                CHECK_r_n_3('1', 7115);
                CHECK_r_n_4('1', 7115);
                CHECK_ar_1("00000000000000000000", 7115);
                CHECK_ar_2("00000000000000000000", 7115);
                CHECK_ar_3("00000000000000000000", 7115);
                CHECK_ar_4("00000000000000000000", 7115);
                -- -------------------------------------
                WAIT FOR 3085 ns;

                IF (TX_ERROR = 0) THEN
                    STD.TEXTIO.write(TX_OUT, string'("No errors or warnings"));
                    ASSERT (FALSE) REPORT
                      "Simulation successful (not a failure).  No problems detected."
                      SEVERITY FAILURE;
                ELSE
                    STD.TEXTIO.write(TX_OUT, TX_ERROR);
                    STD.TEXTIO.write(TX_OUT,
                        string'(" errors found in simulation"));
                    ASSERT (FALSE) REPORT "Errors found during simulation"
                         SEVERITY FAILURE;
                END IF;
            END PROCESS;

    END testbench_arch;

