set tc "tc_01"

if {[info exists aldec]} then {
    set simulator "aldec"
} else {
    set simulator "modelsim"
}

set StdArithNoWarnings 1

if {$simulator == "aldec"} then {
    echo "Running Aldec Riviera"
    vsim top_tb -ieee_nowarn -gfabric_input="$tc/fabric.in"
} else {
    echo "Running Modelsim"
}

log -r /*
run 20 us

if {$simulator != "aldec"} then {
    exit -f
}

